
var m = require('./');
var bm = require('benchmark');

/*
 *
 * without bound exec() x 2,961,891 ops/sec ±1.03% (95 runs sampled)
 *
 * with bound exec() x 454,627 ops/sec ±1.80% (83 runs sampled)
 */


var suite = new bm.Suite;
var M = m().toConstructor();
M.prototype.thunk = function(){
  var self = this;
  return function(cb){
    self.exec(cb);
  }
}

// add tests
suite.add('using thunk () bound exec()', function() {
  M().thunk()();
  //m().exec();
})
// add listeners
.on('cycle', function(event) {
  console.log(String(event.target));
})
.on('complete', function() {
  console.log('Fastest is ' + this.filter('fastest').pluck('name'));
})
// run async
.run({ 'async': true });


